LIBRARY ieee;
USE ieee.std_logic_1164.all;
----------------------------------------------------------------
ENTITY fsm IS
	PORT(clk		: IN STD_LOGIC;
		 reset		: IN STD_LOGIC;
		 STRB		: IN STD_LOGIC;
         done		: IN STD_LOGIC;

	     OPe		: OUT STD_LOGIC;
	     cA			: OUT STD_LOGIC;
	     sA			: OUT STD_LOGIC;
	     dout0		: OUT STD_LOGIC;
	     dout1		: OUT STD_LOGIC;

	     aSe		: OUT STD_LOGIC;
	     aEe1		: OUT STD_LOGIC;
	     aEe2		: OUT STD_LOGIC;
	     aMe1		: OUT STD_LOGIC;
	     aMe2		: OUT STD_LOGIC;
	     aMe3		: OUT STD_LOGIC;

	     bSe		: OUT STD_LOGIC;
	     bEe1		: OUT STD_LOGIC;
	     bEe2		: OUT STD_LOGIC;
	     bMe1		: OUT STD_LOGIC;
	     bMe2		: OUT STD_LOGIC;
	     bMe3		: OUT STD_LOGIC;

	     waiting	: OUT STD_LOGIC;
	     math		: OUT STD_LOGIC;
         aclr       : OUT STD_LOGIC);
END fsm;
----------------------------------------------------------------
ARCHITECTURE Behavior OF fsm IS
	TYPE CYCLE IS (rset,rest1,rest2,rest3,rest4,waitRiseBforOp,gotOp,waitFallBforOp2,waitRiseBforOp2,gotOp2,waitFallBforA1,waitRiseBforA1,gotA1,waitFallBforA2,waitRiseBforA2,gotA2,waitFallBforA3,waitRiseBforA3,gotA3,waitFallBforA4,waitRiseBforA4,gotA4,waitFallBforB1,waitRiseBforB1,gotB1,waitFallBforB2,waitRiseBforB2,gotB2,waitFallBforB3,waitRiseBforB3,gotB3,waitFallBforB4,waitRiseBforB4,gotB4,waitMath1,waitMath2,sendR1,waitFallBforR1,waitRiseBforR1,sentR1,sendR2,waitFallBforR2,waitRiseBforR2,sentR2,sendR3,waitFallBforR3,waitRiseBforR3,sentR3,sendR4,waitFallBforR4,waitRiseBforR4,waitFallBforReset,hang);
	SIGNAL y : CYCLE;
----------------------------------------------------------------
BEGIN
	PROCESS(reset,clk)
	BEGIN
		IF reset = '1' THEN

    waiting	<= '0';
    math	<= '0';
    aclr	<= '1';
	OPe		<= '1';
	cA		<= '0';
	sA		<= '0';
	dout0	<= '0';
	dout1	<= '0';

	aSe		<= '0';
	aEe1	<= '0';
	aEe2	<= '0';
	aMe1	<= '0';
	aMe2	<= '0';
	aMe3	<= '0';

	bSe		<= '0';
	bEe1	<= '0';
	bEe2	<= '0';
	bMe1	<= '0';
	bMe2	<= '0';
	bMe3	<= '0';

			y <= rset;
		ELSIF(clk'EVENT AND clk='1')THEN
----------------------------------------------------------------
CASE y IS
WHEN rset =>

    waiting	<= '0';
    math	<= '0';
    aclr	<= '1';
	OPe		<= '1';
	cA		<= '0';
	sA		<= '0';
	dout0	<= '0';
	dout1	<= '0';

	aSe		<= '0';
	aEe1	<= '0';
	aEe2	<= '0';
	aMe1	<= '0';
	aMe2	<= '0';
	aMe3	<= '0';

	bSe		<= '0';
	bEe1	<= '0';
	bEe2	<= '0';
	bMe1	<= '0';
	bMe2	<= '0';
	bMe3	<= '0';
       
	y 		<= rest1;

WHEN rest1 =>
	y 		<= rest2;

WHEN rest2 =>
	y 		<= rest3;

WHEN rest3 =>
    aclr	<= '0';
	y 		<= rest4;

WHEN rest4 =>
	y 		<= waitRiseBforOp;
----------------------------------------------------------------
-- assume that if we wake up to a one it is the first rising strB of the message

WHEN waitRiseBforOp =>
    waiting	<= '1';
	IF (STRB='1') THEN
	  y <= gotOp;	
	ELSE
	  y <= waitRiseBforOp;
	END IF;

WHEN gotOp =>
	y 		<= waitFallBforOp2;	

WHEN waitFallBforOp2 =>
	IF (STRB='1') THEN
	  y <= waitFallBforOp2;	
	ELSE
	  y <= waitRiseBforOp2;
	END IF;

WHEN waitRiseBforOp2 =>
	IF (STRB='1') THEN
	  y <= gotOp2;	
	ELSE
	  y <= waitRiseBforOp2;
	END IF;

WHEN gotOp2 =>
    waiting	<= '0';
	OPe 	<= '0';	   
	aSe 	<= '1';	   
	aEe1 	<= '1';
	y 		<= waitFallBforA1;	
----------------------------------------------------------------
WHEN waitFallBforA1 =>
	IF (STRB='1') THEN
	  y <= waitFallBforA1;	
	ELSE
	  y <= waitRiseBforA1;
	END IF;

WHEN waitRiseBforA1 =>
	IF (STRB='1') THEN
	  y <= gotA1;	
	ELSE
	  y <= waitRiseBforA1;
	END IF;

WHEN gotA1 =>
	aSe 	<= '0';	   
	aEe1 	<= '0';
	aEe2 	<= '1';
	aMe1 	<= '1';
	y 		<= waitFallBforA2;	

WHEN waitFallBforA2 =>
	IF (STRB='1') THEN
	  y <= waitFallBforA2;	
	ELSE
	  y <= waitRiseBforA2;
	END IF;

WHEN waitRiseBforA2 =>
	IF (STRB='1') THEN
	  y <= gotA2;	
	ELSE
	  y <= waitRiseBforA2;
	END IF;

WHEN gotA2 =>
	aEe2 	<= '0';
	aMe1 	<= '0';
	aMe2 	<= '1';
	y 		<= waitFallBforA3;	

WHEN waitFallBforA3 =>
	IF (STRB='1') THEN
	  y <= waitFallBforA3;	
	ELSE
	  y <= waitRiseBforA3;
	END IF;

WHEN waitRiseBforA3 =>
	IF (STRB='1') THEN
	  y <= gotA3;	
	ELSE
	  y <= waitRiseBforA3;
	END IF;

WHEN gotA3 =>
	aMe2 	<= '0';
	aMe3 	<= '1';
	y 		<= waitFallBforA4;	

WHEN waitFallBforA4 =>
	IF (STRB='1') THEN
	  y <= waitFallBforA4;	
	ELSE
	  y <= waitRiseBforA4;
	END IF;

WHEN waitRiseBforA4 =>
	IF (STRB='1') THEN
	  y <= gotA4;	
	ELSE
	  y <= waitRiseBforA4;
	END IF;
----------------------------------------------------------------
WHEN gotA4 =>
	aMe3 	<= '0';
	bSe 	<= '1';	   
	bEe1 	<= '1';
	y 		<= waitFallBforB1;	
----------------------------------------------------------------
WHEN waitFallBforB1 =>
	IF (STRB='1') THEN
	  y <= waitFallBforB1;	
	ELSE
	  y <= waitRiseBforB1;
	END IF;

WHEN waitRiseBforB1 =>
	IF (STRB='1') THEN
	  y <= gotB1;	
	ELSE
	  y <= waitRiseBforB1;
	END IF;

WHEN gotB1 =>
	bSe 	<= '0';	   
	bEe1 	<= '0';
	bEe2 	<= '1';
	bMe1 	<= '1';
	y 		<= waitFallBforB2;	

WHEN waitFallBforB2 =>
	IF (STRB='1') THEN
	  y <= waitFallBforB2;	
	ELSE
	  y <= waitRiseBforB2;
	END IF;

WHEN waitRiseBforB2 =>
	IF (STRB='1') THEN
	  y <= gotB2;	
	ELSE
	  y <= waitRiseBforB2;
	END IF;

WHEN gotB2 =>
	bEe2 	<= '0';
	bMe1 	<= '0';
	bMe2 	<= '1';
	y 		<= waitFallBforB3;	

WHEN waitFallBforB3 =>
	IF (STRB='1') THEN
	  y <= waitFallBforB3;	
	ELSE
	  y <= waitRiseBforB3;
	END IF;

WHEN waitRiseBforB3 =>
	IF (STRB='1') THEN
	  y <= gotB3;	
	ELSE
	  y <= waitRiseBforB3;
	END IF;

WHEN gotB3 =>
	bMe2 	<= '0';
	bMe3 	<= '1';
	y 		<= waitFallBforB4;	

WHEN waitFallBforB4 =>
	IF (STRB='1') THEN
	  y <= waitFallBforB4;	
	ELSE
	  y <= waitRiseBforB4;
	END IF;

WHEN waitRiseBforB4 =>
	IF (STRB='1') THEN
	  y <= gotB4;	
	ELSE
	  y <= waitRiseBforB4;
	END IF;
----------------------------------------------------------------
WHEN gotB4 =>
	bMe3 	<= '0';
    math	<= '1';
	y 		<= waitMath1;	
----------------------------------------------------------------
WHEN waitMath1 =>
	IF (done='1') THEN
      math		<= '0';
	  y <= waitMath2;	
	ELSE
	  y <= waitMath1;
	END IF;
WHEN waitMath2 =>
	IF (STRB='1') THEN
	  y <= waitMath2;	-- hang until sending device has disengaged
	ELSE
	  sA 		<= '0';
      cA		<= '1';
	  dout0 	<= '0';
	  dout1 	<= '0';
      y <= sendR1;	
	END IF;
----------------------------------------------------------------
WHEN sendR1 =>
	sA		<= '1';
	IF (STRB='1') THEN
	  y <= waitFallBforR1;	
	ELSE
	  y <= waitRiseBforR1;
	END IF;

WHEN waitFallBforR1 =>
	IF (STRB='1') THEN
	  y <= waitFallBforR1;	
	ELSE
	  y <= waitRiseBforR1;
	END IF;

WHEN waitRiseBforR1 =>
	IF (STRB='1') THEN
	  y <= sentR1;	
	ELSE
	  y <= waitRiseBforR1;
	END IF;

WHEN sentR1 =>
	sA 		<= '0';
    dout0	<= '1';
    dout1	<= '0';
	y 		<= sendR2;	

WHEN sendR2 =>
	sA		<= '1';
	IF (STRB='1') THEN
	  y <= waitFallBforR2;	
	ELSE
	  y <= waitRiseBforR2;
	END IF;

WHEN waitFallBforR2 =>
	IF (STRB='1') THEN
	  y <= waitFallBforR2;	
	ELSE
	  y <= waitRiseBforR2;
	END IF;

WHEN waitRiseBforR2 =>
	IF (STRB='1') THEN
	  y <= sentR2;	
	ELSE
	  y <= waitRiseBforR2;
	END IF;

WHEN sentR2 =>
	sA 		<= '0';
    dout0	<= '0';
    dout1	<= '1';
	y 		<= sendR3;	

WHEN sendR3 =>
	sA		<= '1';
	IF (STRB='1') THEN
	  y <= waitFallBforR3;	
	ELSE
	  y <= waitRiseBforR3;
	END IF;

WHEN waitFallBforR3 =>
	IF (STRB='1') THEN
	  y <= waitFallBforR3;	
	ELSE
	  y <= waitRiseBforR3;
	END IF;

WHEN waitRiseBforR3 =>
	IF (STRB='1') THEN
	  y <= sentR3;	
	ELSE
	  y <= waitRiseBforR3;
	END IF;

WHEN sentR3 =>
	sA 		<= '0';
    dout0	<= '1';
    dout1	<= '1';
	y 		<= sendR4;	

WHEN sendR4 =>
	sA		<= '1';
	IF (STRB='1') THEN
	  y <= waitFallBforR4;	
	ELSE
	  y <= waitRiseBforR4;
	END IF;

WHEN waitFallBforR4 =>
	IF (STRB='1') THEN
	  y <= waitFallBforR4;	
	ELSE
	  y <= waitRiseBforR4;
	END IF;

WHEN waitRiseBforR4 =>
	IF (STRB='1') THEN
	  y <= waitFallBforReset; 
	ELSE
	  y <= waitRiseBforR4;
	END IF;

WHEN waitFallBforReset =>
	IF (STRB='1') THEN
	  y <= waitFallBforReset;
	ELSE
	  y <= rset; --use hang for testing
	END IF;

----------------------------------------------------------------
WHEN hang =>
	y <= hang;

END CASE;
----------------------------------------------------------------
		END IF;
	END PROCESS;
END Behavior;
----------------------------------------------------------------
